﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Controls.Menus;

namespace xamTree_NodeEvents
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        /// <summary>
        /// Double click event attached to XamDataTreeNodeControl. Fired off only on the node.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        void Node_MouseDoubleClick(object sender, MouseButtonEventArgs e)
        {
            XamDataTreeNodeControl nodeControl = sender as XamDataTreeNodeControl;
            if (nodeControl != null)
            {
                // In here you would access your node data.
                if (nodeControl.Node.Data.GetType() == typeof(SampleStates))
                {
                    SampleStates state = nodeControl.Node.Data as SampleStates;
                    Console.WriteLine("State Node Clicked: " + state.StateName);
                }
                else if (nodeControl.Node.Data.GetType() == typeof(SampleCities))
                {
                    SampleCities city = nodeControl.Node.Data as SampleCities;
                    Console.WriteLine("City Node Clicked: " + city.StateName);
                }
            }
        }

        void asas(object sender, MouseButtonEventArgs e)
        {
            XamDataTreeNodeControl nodeControl = sender as XamDataTreeNodeControl;
            if (nodeControl != null)
            {
                if (!nodeControl.Node.IsSelected)
                {
                    nodeControl.Node.IsActive = true;
                    nodeControl.Node.IsSelected = true;
                }
            }
        }

        private XamDataTreeNodeControl dd = null;
        void ss(object sender, MouseButtonEventArgs e)
        {
            XamDataTreeNodeControl nodeControl = sender as XamDataTreeNodeControl;
            if (nodeControl != null)
            {
                if (nodeControl.Node.IsSelected)
                {
                    if (!((Keyboard.Modifiers & ModifierKeys.Shift) > 0 || (Keyboard.Modifiers & ModifierKeys.Control) > 0) && !(e.OriginalSource.GetType() == typeof(Grid) && (e.OriginalSource as Grid).Children[0].GetType() == typeof(Path) || e.OriginalSource.GetType() == typeof(Path)))
                    {
                        dd = nodeControl;
                        e.Handled = true;
                    }
                }
            }
        }

        void sas(object sender, MouseButtonEventArgs e)
        {
            XamDataTreeNodeControl nodeControl = sender as XamDataTreeNodeControl;
            if (nodeControl != null)
            {
                if (!((Keyboard.Modifiers & ModifierKeys.Shift) > 0 || (Keyboard.Modifiers & ModifierKeys.Control) > 0) && nodeControl == dd && e.OriginalSource.GetType() != typeof(Grid))
                {
                      nodeControl.Node.IsActive = true;
                      nodeControl.Node.IsSelected = true;
                }
            }
        }

        /// <summary>
        /// Double click event attached to the XamDataTree. Fired off anywhere in the tree.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void SampleTree_MouseDoubleClick(object sender, MouseButtonEventArgs e)
        {
            Console.WriteLine("XamDataTree: Double click!");
        }
    }
}
